package ru.samsung.itschool.testbed;

import java.io.PrintStream;
import java.util.Scanner;

import my_program.MyProgram;
import samsung.testbed.R;
import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.activity_main);

		consoleWrite = (TextView) findViewById(R.id.consoleWrite);
		valuePrompt = (EditText) findViewById(R.id.valuePrompt);
		closeButton = (Button) findViewById(R.id.closeButton);

		// valuePrompt.setVisibility(View.GONE);

		hOut = new PrintoutHandler();
		hIn = new ScanInHandler();

		(new RunUserProgram()).execute();

		valuePrompt.setOnKeyListener(new View.OnKeyListener() {
			public boolean onKey(View v, int keyCode, KeyEvent event) {
				if (event.getAction() == KeyEvent.ACTION_DOWN
						&& (keyCode == KeyEvent.KEYCODE_ENTER)) {
					String value = valuePrompt.getText().toString();
					in.process(value);
					valuePrompt.setText("");
					valuePrompt.setVisibility(View.INVISIBLE);

					return true;
				}
				return false;
			}
		});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle action bar item clicks here. The action bar will
		// automatically handle clicks on the Home/Up button, so long
		// as you specify a parent activity in AndroidManifest.xml.
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	// TODO activity deal to get string really
	private static final class ScanInHandler extends Handler {
		public void handleMessage(android.os.Message msg) {
			valuePrompt.setVisibility(View.VISIBLE);
		}
	}

	public void stop(View v) {
		java.lang.System.exit(0);
		// this.finish();
	}

	private static final class PrintoutHandler extends Handler {
		public void handleMessage(android.os.Message msg) {
			// update TextView
			String readText = consoleWrite.getText().toString();
			consoleWrite.setText(readText + msg.obj);
		}
	}

	public static Handler hOut;
	public static Handler hIn;

	private class RunUserProgram extends AsyncTask<Void, Void, String> {

		@Override
		protected String doInBackground(Void... params) {
			try {

				MyProgram.in = new Scanner(in);
				MyProgram.out = new PrintStream(out);
				MyProgram.out.println("Program started.");
				MyProgram.main(new String[0]);
				MyProgram.out.println("The End.");

			} catch (Throwable error) {
				String message = "\nERROR : " + error.toString();
				message += "\n\nError lines:\n";

				for (StackTraceElement e : error.getStackTrace()) {
					String pos = e.toString();
					String packageName = "myprogram";
					String prefixToSearch = packageName + ".";
					if (pos.contains(prefixToSearch)) {
						message += "\n"
								+ pos.substring(pos.indexOf(prefixToSearch)
										+ prefixToSearch.length());
					}
				}
				MyProgram.out.println(message);
				return getString(R.string.program_stopped);
			}
			return getString(R.string.program_finished);
		}

		protected void onPostExecute(String stopMessage) {
			valuePrompt.setVisibility(View.VISIBLE);
			valuePrompt.setText(stopMessage);
			valuePrompt.setEnabled(false);
			closeButton.setVisibility(View.VISIBLE);
		}
	}

	private static TextView consoleWrite;
	private static EditText valuePrompt;
	private Button closeButton;
	public AndroidOutputStream out = new AndroidOutputStream(new TextFlusher() {

		@Override
		public void flush(String text) {
			Message m = MainActivity.hOut.obtainMessage(0, text);
			MainActivity.hOut.sendMessage(m);
		}
	});
	public AndroidInputStream in = new AndroidInputStream();
}
